#include <stdlib.h>
#include <stdio.h>

#include "include/file.h"

void get_file_from_uri(char** uri, char** buffer)
{
	char* tok;
	FILE* f;
	int err;
	size_t bufsize, newlen;



	// this is assuming absPath, NOT abs uri
	//
	// absURI is ONLY generate them in requests to proxies, otherwise
	// will be an abs path

	/**
	 * TODO: if no file is specified, append index.html
	 */
	f = fopen(*uri, "r");
	if (f == NULL) {
		perror("fopen");
		exit(EXIT_FAILURE);
	}

	err = fseek(f, 0L, SEEK_END); // go to the end of the file
	if (err != 0) {
		perror("fseek");
		fclose(f);
		exit(EXIT_FAILURE);
	}

	bufsize = ftell(f); // lets get the length of the file here
	if (bufsize == -1) {
		perror("ftell");
		fclose(f);
		exit(EXIT_FAILURE);
	}

	(*buffer) = malloc(sizeof(char) * (bufsize + 1));
	if (*buffer == NULL) {
		perror("malloc");
		fclose(f);
		exit(EXIT_FAILURE);
	}

	rewind(f); // go back to the beginning of the file
	
	newlen = fread(*buffer, sizeof(char), bufsize, f);
	if (ferror(f) != 0) {
		perror("fread");
		fclose(f);
		exit(EXIT_FAILURE);
	} else {
		(*buffer)[newlen++] = '\0'; // this is just to be safe
	}

	fclose(f);
}
