#include <arpa/inet.h>

#ifndef TCP_H
#define TCP_H

/// Default HTTP port
#define DEFAULT_PORT 8080

#define BUFFER_INC_LEN 200

typedef struct {
	int socket;
	struct sockaddr_in server_info;
	size_t server_info_len;
} server_conn_t;

void setup_socket(server_conn_t* conn);

int recv_message(char** buffer, int socket);

/// Threaded function to handle http requests
/// takes client socket as an argument
void* connection_handler(void* arg);


#endif
