#include <stdio.h>
#include <unistd.h>
#include <pthread.h>
#include <stdbool.h>

#include "include/tcp.h"

/**
 * TODO:
 *
 * we need to parse the request headers and put them into a struct
 *
 * also need to implement the features the headers are requesting
 *
 * for now we're just using the request line and the status line for basic info
 * but eventually i would like to start implementing headers
 *
 * file config for port, file location, etc
 *
 * send INTERNAL SERVER ERROR for failures instead of exiting the thread
 *
 * send 404 for if the file couldnt be found (use errno for this)
 *
 * setup the http_request parser to fill the request struct
 *
 * set the init_response to fill the required default headers (e.g. date)
 *
 * TODO: see where content-length is supposed to be ?
 * TODO: first thing we want to do is start sending a basic response
 * aka, make the status line, fill content-length and fill the message body,
 * then send it
 *
 * cleanup, make sure everything is being free'd and properly cleaned up
 *
 * final: 
 * would like to have a cache at some point
 * make sure everything is fully rfc compliant
 * segment the code even more to make stuff as resuable as possible
 */


int main(void)
{
	server_conn_t server;
	pthread_t client_thread;
	int client_sock, err;
	
	setup_socket(&server);
	puts("Server setup succesfully!");

	puts("Accepting new connections...");
	while (true) {
		client_sock = accept(server.socket, (struct sockaddr*) &(server.server_info),
				(socklen_t*) &(server.server_info_len));
		if (client_sock == -1) {
			perror("accept");
			continue;
		}

		printf("Connection established with %s\n", 
				inet_ntoa(server.server_info.sin_addr));

		err = pthread_create(&client_thread, NULL, connection_handler, &client_sock);
		if (err != 0) {
			perror("pthread_create");
			continue;
		}

		err = pthread_detach(client_thread);
		if (err != 0) {
			perror("pthread_detach");
			continue;
		}
	}

	close(server.socket);

	
	return 0;
}
